function gui(definition)
    local function parse()
        for _, item in ipairs(definition) do
            if type(item) == "table" and item[1] and type(item[1]) == "string" then
                -- Dynamically calls the corresponding function in ui with the prefix builder_
                local func = ui["builder_" .. item[1]]
                if func then
                    func(ui, table.unpack(item, 2))
                else
                    error("No such function: builder_" .. key, 2)
                end
            end
        end
    end

    return {
        ui = definition,
        render = function()
            ui:builder_start()
            parse()
            ui:builder_end()
        end
    }
end
